# Tornado Cash SDK

A collection of Typescript packages which enable you to easily use the Tornado Cash protocol. Please note that you should familiarize yourself with any still experimental functions, this will be the first link below.

* [Experimental features](./EXPERIMENTAL.md)
* [Installation](./INSTALLATION.md)
* [Usage](./USAGE.md)

## API Docs

In order to check out the api docs, either `git clone` the repository and open in a web browser `docs/api/index.html`, or `git clone https://development.tornadocash.community/T-Hax/sdk-api-docs` and open `api/index.ts` in a web browser.

## Package list and short descriptions

* **@tornado/sdk** - this package bundles all of the below packages into one, which can then be imported into a project. It does not provide a default import, instead you may alias it as wished.

* **@tornado/sdk-core** - provides `Core` which provides all of the main Tornado Cash Classic logic, including relatively sensible blockchain synchronization.

* **@tornado/sdk-web** - provides torified web utilities (HTTP Client, ethers provider) and a Relayer utility class.

* **@tornado/sdk-chain** - provides EVM utilities, including a class which can be used relatively easily to synchronize events.

* **@tornado/sdk-data** - provides FS utilities and cache (PouchDB) wrapper classes, one of which is used in tandem with above Synchronizer for syncing.

* **@tornado/sdk-utils** - provides utilities most notably a handler which allows resolving promises with nested callbacks concurrently.